/*
 * Copyright 2019 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.verilog.parser;

import org.junit.Test;
import ru.ispras.verilog.parser.util.VerilogBenchmarkTest;

import java.io.File;
import java.nio.file.Paths;

/**
 * Basic class for IEEE Std 1800-2012 jUnit test cases.
 *
 * @author <a href="mailto:lebedev@ispras.ru">Mikhail Lebedev</a>
 */
public final class SvaIeeeTestSuite extends VerilogBenchmarkTest {

  @Test
  public void run_test_16_03_00() {
    runTest("test", "test_16_03_00.sv");
  }

  @Test
  public void run_test_16_04_02_1() {
    runTest("test", "test_16_04_02_1.sv");
  }

  @Test
  public void run_test_16_04_02_2() {
    runTest("test", "test_16_04_02_2.sv");
  }

  @Test
  public void run_test_16_04_03() {
    runTest("test", "test_16_04_03.sv");
  }

  @Test
  public void run_test_16_06_00_1() {
    runTest("test", "test_16_06_00_1.sv");
  }

  @Test
  public void run_test_16_06_00_2() {
    runTest("test", "test_16_06_00_2.sv");
  }

  @Test
  public void run_test_16_08_00_1() {
    runTest("test", "test_16_08_00_1.sv");
  }

  @Test
  public void run_test_16_08_00_2() {
    runTest("test", "test_16_08_00_2.sv");
  }

  @Test
  public void run_test_16_08_00_3() {
    runTest("test", "test_16_08_00_3.sv");
  }

  @Test
  public void run_test_16_08_00_4() {
    runTest("test", "test_16_08_00_4.sv");
  }

  @Test
  public void run_test_16_08_00_5() {
    runTest("test", "test_16_08_00_5.sv");
  }

  @Test
  public void run_test_16_08_00_6() {
    runTest("test", "test_16_08_00_6.sv");
  }

  @Test
  public void run_test_16_08_01_1() {
    runTest("test", "test_16_08_01_1.sv");
  }

  @Test
  public void run_test_16_08_01_2() {
    runTest("test", "test_16_08_01_2.sv");
  }

  @Test
  public void run_test_16_08_01_3() {
    runTest("test", "test_16_08_01_3.sv");
  }

  @Test
  public void run_test_16_08_02_1() {
    runTest("test", "test_16_08_02_1.sv");
  }

  @Test
  public void run_test_16_08_02_2() {
    runTest("test", "test_16_08_02_2.sv");
  }

  @Test
  public void run_test_16_08_02_3() {
    runTest("test", "test_16_08_02_3.sv");
  }

  @Test
  public void run_test_16_08_02_4() {
    runTest("test", "test_16_08_02_4.sv");
  }

  @Test
  public void run_test_16_09_02() {
    runTest("test", "test_16_09_02.sv");
  }

  @Test
  public void run_test_16_09_03() {
    runTest("test", "test_16_09_03.sv");
  }

  @Test
  public void run_test_16_09_04() {
    runTest("test", "test_16_09_04.sv");
  }

  @Test
  public void run_test_16_09_05() {
    runTest("test", "test_16_09_05.sv");
  }

  @Test
  public void run_test_16_09_06() {
    runTest("test", "test_16_09_06.sv");
  }

  @Test
  public void run_test_16_09_07() {
    runTest("test", "test_16_09_07.sv");
  }

  @Test
  public void run_test_16_09_08_1() {
    runTest("test", "test_16_09_08_1.sv");
  }

  @Test
  public void run_test_16_09_08_2() {
    runTest("test", "test_16_09_08_2.sv");
  }

  @Test
  public void run_test_16_09_09() {
    runTest("test", "test_16_09_09.sv");
  }

  @Test
  public void run_test_16_09_10() {
    runTest("test", "test_16_09_10.sv");
  }

  @Test
  public void run_test_16_09_11() {
    runTest("test", "test_16_09_11.sv");
  }

  @Test
  public void run_test_16_10_00_1() {
    runTest("test", "test_16_10_00_1.sv");
  }

  @Test
  public void run_test_16_10_00_2() {
    runTest("test", "test_16_10_00_2.sv");
  }

  @Test
  public void run_test_16_10_00_3() {
    runTest("test", "test_16_10_00_3.sv");
  }

  @Test
  public void run_test_16_10_00_4() {
    runTest("test", "test_16_10_00_4.sv");
  }

  @Test
  public void run_test_16_10_00_5() {
    runTest("test", "test_16_10_00_5.sv");
  }

  @Test
  public void run_test_16_10_00_6() {
    runTest("test", "test_16_10_00_6.sv");
  }

  @Test
  public void run_test_16_10_00_7() {
    runTest("test", "test_16_10_00_7.sv");
  }

  @Test
  public void run_test_16_11_00() {
    runTest("test", "test_16_11_00.sv");
  }

  @Test
  public void run_test_16_12_01() {
    runTest("test", "test_16_12_01.sv");
  }

  @Test
  public void run_test_16_12_02() {
    runTest("test", "test_16_12_02.sv");
  }

  @Test
  public void run_test_16_12_06_1() {
    runTest("test", "test_16_12_06_1.sv");
  }

  @Test
  public void run_test_16_12_06_2() {
    runTest("test", "test_16_12_06_2.sv");
  }

  @Test
  public void run_test_16_12_06_3() {
    runTest("test", "test_16_12_06_3.sv");
  }

  @Test
  public void run_test_16_12_10() {
    runTest("test", "test_16_12_10.sv");
  }

  @Test
  public void run_test_16_12_11() {
    runTest("test", "test_16_12_11.sv");
  }

  @Test
  public void run_test_16_12_12() {
    runTest("test", "test_16_12_12.sv");
  }

  @Test
  public void run_test_16_12_13() {
    runTest("test", "test_16_12_13.sv");
  }

  @Test
  public void run_test_16_12_14() {
    runTest("test", "test_16_12_14.sv");
  }

  @Test
  public void run_test_16_12_16() {
    runTest("test", "test_16_12_16.sv");
  }

  @Test
  public void run_test_16_12_17_1() {
    runTest("test", "test_16_12_17_1.sv");
  }

  @Test
  public void run_test_16_12_17_2() {
    runTest("test", "test_16_12_17_2.sv");
  }

  @Test
  public void run_test_16_12_17_3() {
    runTest("test", "test_16_12_17_3.sv");
  }

  @Test
  public void run_test_16_12_17_4() {
    runTest("test", "test_16_12_17_4.sv");
  }

  @Test
  public void run_test_16_12_17_5() {
    runTest("test", "test_16_12_17_5.sv");
  }

  @Test
  public void run_test_16_12_20() {
    runTest("test", "test_16_12_20.sv");
  }

  @Test
  public void run_test_16_13_04() {
    runTest("test", "test_16_13_04.sv");
  }

  @Test
  public void run_test_16_13_07() {
    runTest("test", "test_16_13_07.sv");
  }

  @Test
  public void run_test_16_14_01() {
    runTest("test", "test_16_14_01.sv");
  }

  @Test
  public void run_test_16_14_02() {
    runTest("test", "test_16_14_02.sv");
  }

  @Test
  public void run_test_16_14_05() {
    runTest("top", "test_16_14_05.sv");
  }

  @Test
  public void run_test_16_14_06_00_1() {
    runTest("test", "test_16_14_06_00_1.sv");
  }

  @Test
  public void run_test_16_14_06_00_2() {
    runTest("test", "test_16_14_06_00_2.sv");
  }

  @Test
  public void run_test_16_14_06_01_1() {
    runTest("test", "test_16_14_06_01_1.sv");
  }

  @Test
  public void run_test_16_14_06_01_2() {
    runTest("test", "test_16_14_06_01_2.sv");
  }

  @Test
  public void run_test_16_14_06_01_3() {
    runTest("test", "test_16_14_06_01_3.sv");
  }

  @Override
  public String getTestDirPath() {
    return System.getProperty("user.dir")
        + File.separator
        + Paths.get("src", "test", "verilog", "sva-ieee-tests").toString()
        + File.separator;
  }
}
