/*
 * Copyright 2019 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.verilog.parser;

import org.junit.Test;
import ru.ispras.verilog.parser.util.VerilogBenchmarkTest;

import java.io.File;
import java.nio.file.Paths;

/**
 * Verilog2Smv\VCEGAR benchmark jUnit test cases.
 * @author <a href="mailto:smolov@ispras.ru">Sergey Smolov</a>
 */
public class Verilog2SmvVcegarTestSuite extends VerilogBenchmarkTest {

  /* AR */

  @Test
  public void runTest_AR_ar() {
    runTest("main", Paths.get("AR", "ar.v").toString());
  }

  /* ipbdp */

  @Test
  public void runTest_ipbdp_hier_p1() {
    runTest("IPBDP_hier", Paths.get("ipbdp", "ipbdp_hier_p1.v").toString());
  }

  @Test
  public void runTest_ipbdp_hier_p2() {
    runTest("IPBDP_hier", Paths.get("ipbdp", "ipbdp_hier_p2.v").toString());
  }

  /* itc99_b12 */

  @Test
  public void runTest_itc99_b12_p1() {
    runTest("main", Paths.get("itc99_b12", "itc99_b12_p1.v").toString());
  }

  @Test
  public void runTest_itc99_b12_p2() {
    runTest("main", Paths.get("itc99_b12", "itc99_b12_p2.v").toString());
  }

  /* itc99_b13 */

  @Test
  public void runTest_itc99_b13_p01() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p01.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p02() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p02.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p03() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p03.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p04() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p04.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p05() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p05.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p06() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p06.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p07() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p07.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p08() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p08.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p09() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p09.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p10() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p10.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p11() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p11.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p12() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p12.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p13() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p13.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p14() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p14.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p15() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p15.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p16() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p16.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p17() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p17.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p18() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p18.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p19() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p19.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p20() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p20.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p21() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p21.v").toString());
  }

  @Test
  public void runTest_itc99_b13_p22() {
    runTest("main", Paths.get("itc99_b13", "itc99_b13_p22.v").toString());
  }

  /* pi_bus */

  @Test
  public void runTest_pi_bus() {
    runTest("master_controller", Paths.get("pi_bus", "pi_bus.v").toString());
  }

  /* pj_icu */

  @Test
  public void runTest_pj_icu_icctl_p1() {
    runTest("icctl", Paths.get("pj_icu", "pj_icu_icctl_p1.v").toString());
  }

  @Test
  public void runTest_pj_icu_icctl_p2() {
    runTest("icctl", Paths.get("pj_icu", "pj_icu_icctl_p2.v").toString());
  }

  @Test
  public void runTest_pj_icu_icctl_p3() {
    runTest("icctl", Paths.get("pj_icu", "pj_icu_icctl_p3.v").toString());
  }

  @Test
  public void runTest_pj_icu_icctl_p4() {
    runTest("icctl", Paths.get("pj_icu", "pj_icu_icctl_p4.v").toString());
  }

  /* sdlx */

  @Test
  public void runTest_sdlx_control() {
    runTest("main", Paths.get("sdlx", "sdlx_control.v").toString());
  }

  /* usb_phy */

  @Test
  public void runTest_usb_phy_1() {
    runTest("main", Paths.get("usb_phy", "usb_phy_1.v").toString());
  }

  /* zaher */

  @Test
  public void runTest_zaher() {
    runTest("main", Paths.get("zaher", "zdlx_impl.v_for_pred.v").toString());
  }

  @Override
  public String getTestDirPath() {
    return System.getProperty("user.dir")
        + File.separator
        + Paths.get("src", "test", "verilog", "hdl-benchmarks", "hdl", "verilog2smv", "VCEGAR")
            .toString()
        + File.separator;
  }
}
