/*
 * Copyright 2020 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ru.ispras.verilog.parser.sample;

import java.nio.file.Paths;

/**
 * Test for "bug9990/test3.v" Verilog module.
 *
 * @author <a href="mailto:aadanilov_3@edu.hse.ru">Danilov Alexey</a>
 */
public class Bug9990Test3TestCase extends VerilogPrinterTestCase {

  @Override
  public String[] getOptions() {
    return new String[] {
        "--include-path",
        getFullPathPrefix() + "bugs-tests/bug9990"
    };
  }

  @Override
  public Boolean isError() {
    return Boolean.TRUE;
  }

  @Override
  public String[] getPaths() {
    return new String[] {
        Paths.get("bugs-tests", "bug9990", "test3.v").toString()
    };
  }
}
