/*
 * Copyright 2020 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ru.ispras.verilog.parser.sample;

import org.junit.Test;
import ru.ispras.verilog.parser.util.VerilogBenchmarkTest;

import java.io.File;
import java.nio.file.Paths;

/**
 * Test for "assign_checker/test.v" Verilog module.
 *
 * @author <a href="mailto:aadanilov_3@edu.hse.ru">Danilov Alexey</a>
 */
public class DeclarationTestCase extends VerilogBenchmarkTest {

  @Test(expected = IllegalArgumentException.class)
  public void runTest_param1() {
    runTest("param1", Paths.get("param1.v").toString());
  }

  @Test(expected = IllegalArgumentException.class)
  public void runTest_param2() {
    runTest("param2", Paths.get("param2.v").toString());
  }

  @Test(expected = IllegalArgumentException.class)
  public void runTest_param3() {
    runTest("param3", Paths.get("param3.v").toString());
  }

  @Test(expected = IllegalArgumentException.class)
  public void runTest_param4() {
    runTest("param4", Paths.get("param4.v").toString());
  }

  @Test(expected = IllegalArgumentException.class)
  public void runTest_reg1() {
    runTest("reg1", Paths.get("reg1.v").toString());
  }

  @Test(expected = IllegalArgumentException.class)
  public void runTest_reg2() {
    runTest("reg2", Paths.get("reg2.v").toString());
  }

  @Test(expected = IllegalArgumentException.class)
  public void runTest_reg3() {
    runTest("reg3", Paths.get("reg3.v").toString());
  }

  @Test(expected = IllegalArgumentException.class)
  public void runTest_specparam1() {
    runTest("specparam1", Paths.get("specparam1.v").toString());
  }

  @Test(expected = IllegalArgumentException.class)
  public void runTest_specparam2() {
    runTest("specparam2", Paths.get("specparam2.v").toString());
  }

  @Test(expected = IllegalArgumentException.class)
  public void runTest_specparam3() {
    runTest("specparam3", Paths.get("specparam3.v").toString());
  }

  @Test(expected = IllegalArgumentException.class)
  public void runTest_wire1() {
    runTest("wire1", Paths.get("wire1.v").toString());
  }

  @Test(expected = IllegalArgumentException.class)
  public void runTest_wire2() {
    runTest("wire2", Paths.get("wire2.v").toString());
  }

  @Test(expected = IllegalArgumentException.class)
  public void runTest_wire3() {
    runTest("wire3", Paths.get("wire3.v").toString());
  }

  @Override
  public String getTestDirPath() {
    return System.getProperty("user.dir")
        + File.separator
        + Paths.get("src", "test", "verilog", "rest-tests", "declaration_checker").toString()
        + File.separator;
  }
}
