/*
 * Copyright 2020 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ru.ispras.verilog.parser.sample;

import org.junit.Test;
import ru.ispras.verilog.parser.util.VerilogBenchmarkTest;

import java.io.File;
import java.nio.file.Paths;

/**
 * Test for "assign_checker/test.v" Verilog module.
 *
 * @author <a href="mailto:aadanilov_3@edu.hse.ru">Danilov Alexey</a>
 */
public class GenerateWarnTestCase extends VerilogBenchmarkTest {

  @Test(expected = IllegalArgumentException.class)
  public void runTest_forStatement() {
    runTest("mod_a", Paths.get("for_statement.v").toString());
  }

  @Test
  public void runTest_defparam() {
    runTest("test2", Paths.get("defparam.v").toString());
  }

  @Override
  public String getTestDirPath() {
    return System.getProperty("user.dir")
        + File.separator
        + Paths.get("src", "test", "verilog", "rest-tests", "generate").toString()
        + File.separator;
  }
}
