`timescale 1ns/1ps

module adder4(op1, op2, res, overflow);
  input  [3:0] op1;
  input  [3:0] op2;
  output [3:0] res;
  output overflow;

  wire c01, c12, c23, c34;

  assign res[0] = op1[0] ^ op2[0];
  assign res[1] = op1[1] ^ op2[1] ^ c01;
  assign res[2] = op1[2] ^ op2[2] ^ c12;
  assign res[3] = op1[3] ^ op2[3] ^ c23;

  assign c01 = op1[0] & op2[0];
  assign c12 = op1[1] & op2[1] | op1[1] & c01 | op2[1] & c01;
  assign c23 = op1[2] & op2[2] | op1[2] & c12 | op2[2] & c12;
  assign c34 = op1[3] & op2[3] | op1[3] & c23 | op2[3] & c23;

  assign overflow = c34;
  
endmodule /* adder4 */

