`include "fifo36.v"


module fifo36_testbench;
  reg clk;
  wire [7:0] rxfifo_do;
  wire rxfifo_empty;
  wire rxfifo_full;
  wire [12:0] rxfifo_wrcount;
  wire [12:0] rxfifo_rdcount;
  wire rxfifo_wrerr;
  reg [7:0] rxfifo_di;
  reg rxfifo_wren;
  reg rxfifo_rden;
  reg rxfifo_rst;

  FIFO36
  #(
    .DATA_WIDTH(9),
    .DO_REG(1),
    .EN_SYN("TRUE")
   )
  RXFIFO
  (
    .DO(rxfifo_do[7:0]),
    .DOP(),
    .EMPTY(rxfifo_empty),
    .FULL(rxfifo_full),
    .RDCOUNT(rxfifo_rdcount),
    .RDERR(),
    .WRCOUNT(rxfifo_wrcount),
    .WRERR(rxfifo_wrerr),
    .DI({24'h0, rxfifo_di}),
    .DIP(4'h0),
    .RDCLK(CLK),
    .RDEN(rxfifo_rden),
    .RST(rxfifo_rst),
    .WRCLK(CLK),
    .WREN(rxfifo_wren)
  );
endmodule