/*
 * Copyright 2020 ISP RAS (http://www.ispras.ru)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

module test;

reg i, j;
reg q, r, s, t;

sequence s1(x, y, z);
  x ##1 y + z;
endsequence

sequence s2(w, v, u);
  w || v + u;
endsequence

sequence s3(k, l, m, n);
  reg o = 0;
  reg p = 1;
  s1(k, l, o) or s2(m, n, p);
endsequence

property p1(a, b, c, d);
  s3(a, b, c, d);
endproperty

assert property (p1(i, 1, j, 0) or p1(q, r, s, t));

endmodule
